
/***************************************************************************
                 module classe ta_sa_trasbc.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 16, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3)
{/*	1	from	sbcgyre_qsr_qns		2  i 	j         t
	2	from	sbcgyre_emp_emps	2  i 	j         t
	3	from	sa			1  i 	j    1    t-1*/
  /*verification 
    YS1 
        1.753076792770611e-11
	5.732210634606206e-08
    YS2
        2.455612530130739e-13
        1.665460565783498e-07
  */
  if(Yt==TU)
    YS1=0.;
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0){
      YS1=0.;
      YS2=0.;
    }
    else{
      double  zse3t = 1. / fse3t(Yi,Yj,0);
      double  zsrau = 1. / rauw ;//            ! initialization
      //MODIF JUL
      //x1=0;
      //FIN MODIF
      
      YS1 = ro0cpr * x1*zse3t; //     ! temperature : heat flux
      YS2 = x2*zsrau*x3*zse3t;//     ! salinity :  concent./dilut. effect
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3)
{
  YJ1I1=0.;     YJ1I2=0.;     YJ1I3=0.; 
  YJ2I1=0.;     YJ2I2=0.;     YJ2I3=0.; 
  
  if(Yt!=TU){
    if(Yi==0 || Yi==NX-1 || Yj==0){
      YJ1I1=0.;     YJ1I2=0.;     YJ1I3=0.; 
      YJ2I1=0.;     YJ2I2=0.;     YJ2I3=0.; 
    }
    else{
      double  zse3t = 1. / fse3t(Yi,Yj,0);
      double  zsrau = 1. / rauw ;//            ! initialization
      
      YJ1I1=ro0cpr*zse3t; 
      
      YJ2I2=zsrau*x3*zse3t;
      YJ2I3=x2*zsrau*zse3t; 
    }
  }
  //  
  
}

//===========================================================================
//********************* FIN DU MODULE ta_sa_trasbc **********************

