
/***************************************************************************
                 module classe ta_traqsr.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 25, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1, YREAL x2)
{ /*	1	from	sbcgyre_qsr_qns		1  i 	j         t
	2	from	ta_sa_trasbc		1  i 	j         t*/
  /* verification calcul
     A 1.903724252353736e-11
     R 7.053989989415242e-08*/
  if(Yt==TU)
    YS1=0.;
  else{
    double zc0, zta;
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk>=nksr){
      YS1=0.;
      if(Yk==0) YS1 = x2;
    }
    else{
      zc0 = x1/e3t_0[Yk]; //x1 / fse3t(ji,jj,jk)
      //! qsr trend
      zta = zc0*(gdsr[Yk]*tmask(Yi,Yj,Yk) - gdsr[Yk+1]*tmask(Yi,Yj,Yk+1));
      //! add qsr trend to the temperature trend
      if(Yk==0) YS1 = x2+ zta;
      else YS1=zta;
    }
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1, YREAL x2)
{
  YJ1I1=0.;     YJ1I2=0.; 
  
  if(Yt!=TU){
    double zc0, zta,dzc0_x1,dzta_x1;
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk>=nksr){
      YJ1I1=0.;     YJ1I2=0.; 
      if(Yk==0) YJ1I2=1.;//YS1 = x2;
    }
    else{
      zc0 = x1/e3t_0[Yk]; //x1 / fse3t(ji,jj,jk)
      dzc0_x1 = 1./e3t_0[Yk];
      //! qsr trend
      zta = zc0*(gdsr[Yk]*tmask(Yi,Yj,Yk) - gdsr[Yk+1]*tmask(Yi,Yj,Yk+1));
      dzta_x1 = dzc0_x1*(gdsr[Yk]*tmask(Yi,Yj,Yk) - gdsr[Yk+1]*tmask(Yi,Yj,Yk+1));
      //! add qsr trend to the temperature trend
      if(Yk==0){
	YJ1I1=dzta_x1;
	YJ1I2=1.;//YS1 = x2+ zta;
      }
      else YJ1I1=dzta_x1;
    }
  }
  //
  
}

//===========================================================================
//***********************  FIN DU MODULE ta_traqsr   ************************

