
/***************************************************************************
                 module classe ua_dynadv_cen2.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, February 27, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3)
{/*	x1	from	zfuv_UW_dynadv_cen2	1  i    j    k    t
	x2	from	zfuv_UW_dynadv_cen2	1  i    j    k+1  t
	x3	from	zua_dhmf_dynadv_cen2	1  i    j    k    t*/

  if(Yt==TU)
    YS1=0.;
  else{
    double zua;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1)
      YS1=0.;
    else{
      zua=-(x1-x2)/(e1u(Yi,Yj)*e2u(Yi,Yj)*fse3u(Yi,Yj,Yk));
      YS1=zua+x3;
    }
  }
  // if(Yi==2 && Yj==2 && Yk==0) printf("Yt=%d\n",Yt);
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;  
  if(Yt!=TU){  
    double zua,dzua_x1,dzua_x2;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;  
    }
    else{
      zua=-(x1-x2)/(e1u(Yi,Yj)*e2u(Yi,Yj)*fse3u(Yi,Yj,Yk));
      dzua_x1=-1./(e1u(Yi,Yj)*e2u(Yi,Yj)*fse3u(Yi,Yj,Yk));
      dzua_x2=-dzua_x1;
      YJ1I1=dzua_x1;
      YJ1I2=dzua_x2;
      YJ1I3=1.;  
    }
  }
  //  
  //  if(Yi==2 && Yj==2 && Yk==0) printf("Yt=%d\n",Yt);
  
}

//===========================================================================
//********************* FIN DU MODULE ua_dynadv_cen2 **********************
