
/***************************************************************************
                 module classe zwxyz_vor_ene.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 9, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{/*	x1	from	ua			1  i    j    k    t-1
	x2	from	ua			1  i    j+1  k    t-1
	x3	from	va			1  i    j    k    t-1
	x4	from	va			1  i+1  j    k    t-1*/

  /* if (Yi>25 && Yj<3 && Yt<13 && Yk==0)
    {
      printf("zwxyz_vor_ene:Yi=%i, Yj=%i, Yt=%i,x1=%f,x2=%f,x3=%f, x4=%f, YS2=%f\n",Yi,Yj,Yt,x1,x2,x3,x4,e1v(Yi,Yj)*x3);
      }*/

  if(Yt==TU)
    YS1=0.;
  else{
    if(Yk==NZ-1 || Yi==NX-1 || Yj==NY-1) 
      YS1=0.;
    else{
      YS1=e2u(Yi,Yj)*x1;
      YS2=e1v(Yi,Yj)*x3;

      //pour ntot==5--->
      double y31=(x4+x3)*(e2v(Yi+1,Yj)-e2v(Yi,Yj));
      double y32=(x2+x1)*(e1u(Yi,Yj+1)-e1u(Yi,Yj));
      YS3=ff(Yi,Yj)+(y31-y32)*0.5/(e1f(Yi,Yj)*e2f(Yi,Yj));
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;  
  YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;   YJ2I4=0.;  
  YJ3I1=0.;     YJ3I2=0.;   YJ3I3=0.;   YJ3I4=0.;  
  if(Yt!=TU){  
    if(Yk==NZ-1 || Yi==NX-1 || Yj==NY-1) {
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;  
      YJ2I1=0.;     YJ2I2=0.;   YJ2I3=0.;   YJ2I4=0.;  
      YJ3I1=0.;     YJ3I2=0.;   YJ3I3=0.;   YJ3I4=0.;  
    }
    else{
      YJ1I1=e2u(Yi,Yj);
      YJ2I3=e1v(Yi,Yj);
      //pour ntot==5--->
      double dy31_x3=(e2v(Yi+1,Yj)-e2v(Yi,Yj));
      double dy31_x4=(e2v(Yi+1,Yj)-e2v(Yi,Yj));
      double dy32_x1=(e1u(Yi,Yj+1)-e1u(Yi,Yj));
      double dy32_x2=(e1u(Yi,Yj+1)-e1u(Yi,Yj));
      YJ3I1=-dy32_x1*0.5/(e1f(Yi,Yj)*e2f(Yi,Yj));
      YJ3I2=-dy32_x2*0.5/(e1f(Yi,Yj)*e2f(Yi,Yj));
      YJ3I3=dy31_x3*0.5/(e1f(Yi,Yj)*e2f(Yi,Yj));
      YJ3I4=dy31_x4*0.5/(e1f(Yi,Yj)*e2f(Yi,Yj));
    }
  }
  //  
}

//===========================================================================
//********************* FIN DU MODULE zwxyz_vor_ene **********************
